#ifndef BisqNES_defs_h
#define BisqNES_defs_h

#ifdef __cplusplus
extern "C" {
#endif

#include "sizes.h"
#include <endian.h>

typedef char InterruptType;/* Loop6502() returns:        */
#define INT_NONE 0         /* No interrupt required      */
#define INT_IRQ 1          /* Standard IRQ interrupt     */
#define INT_NMI 2          /* Non-maskable interrupt     */
#define INT_QUIT 3         /* Exit the emulation         */

                           /* 6502 status flags:         */
/** Structured Datatypes *************************************/
/** NOTICE: #define LSB_FIRST for machines where least      **/
/**         signifcant byte goes first.                     **/
/*************************************************************/
typedef union
{
#if __BYTE_ORDER==__LITTLE_ENDIAN
  struct { BYTE l,h; } B;
#else
  struct { BYTE h,l; } B;
#endif
  WORD W;
} PAIR;

#ifdef __GNUC__
#define CONSTFUN __attribute__((const))
#else
#define CONSTFUN
#endif

#ifdef __cplusplus
}
#endif

#endif
