#include "papu_internals.hh"
#include "papu_randgenunit.hh"

void rndgen::write(fBYTE ind, fBYTE value)
{
	#if PAPU_RAND_DEBUG
    fprintf(stderr, "rand.write(%u, 0x%02X) -", ind, value);
    #endif
    decayunit::write(ind, value);
    lengthunit::write(ind, value);
    
    if(ind == 2)
    {
        static const WORD wlenconvdata[16] =
        {2*0x002, 2*0x004, 2*0x008, 2*0x010,
         2*0x020, 2*0x030, 2*0x040, 2*0x050,
         2*0x065, 2*0x07F, 2*0x0BE, 2*0x0FE,
         2*0x17D, 2*0x1FC, 2*0x3F9, 2*0x7F2};
        wavelen = wlenconvdata[value & 15];
        randmode = value >> 7;
        #if PAPU_RAND_DEBUG
        fprintf(stderr, "wavelen=%u, mode=%u", wavelen, randmode);
        #endif
    }
    #if PAPU_RAND_DEBUG
    if(silent())
    	fprintf(stderr, "-> silent\n");
    else
    	fprintf(stderr, "-> ok\n");
    #endif
}
